package de.uni_marburg.powersort.data;

public enum DataEnum {
    RANDOM_INTEGERS,
    ASCENDING_INTEGERS,
    DESCENDING_INTEGERS,
    ASCENDING_RUNS,
    ASCENDING_RUNS_WITH_OVERLAP;

    public ObjectSupplier get() {
        // We use a seed to get the same random list every time -> Repeatable benchmarks on same input data!
        // final long seed = 3651660232967549736L; // System.nanoTime() ++ Math.random()
        final long seed = 140506881906827520L; // (long) 'P' * (long) 'O' *(long) 'W' * (long) 'E' * (long) 'R' * (long) 'S' * (long) 'O' * (long) 'R' * (long) 'T';

        int longListSize = 50_000_000;

        return switch (this) {
            case RANDOM_INTEGERS -> new RandomIntegers(longListSize, seed);
            case ASCENDING_INTEGERS -> new AscendingIntegers(longListSize);
            case DESCENDING_INTEGERS -> new DescendingIntegers(longListSize);

            case ASCENDING_RUNS -> AscendingRuns.newAscendingRuns(10_000, 10_000, -10_000);
            case ASCENDING_RUNS_WITH_OVERLAP -> AscendingRuns.newAscendingRuns(10_000, 10_000, -5_000);
        };
    }
}
